package com.example.demo.test;

import java.util.ArrayList;
import java.util.List;
import java.util.OptionalDouble;
import java.util.stream.Collectors;
import java.util.stream.DoubleStream;
import java.util.stream.Stream;

public class Test {

    public static void main(String[] args) {


        //创建对象
        Student student1 = new Student(1, "张三", "语文", 80.0);
        Student student2 = new Student(2, "张三", "数学", 81.5);
        Student student3 = new Student(3, "李四", "语文", 90.0);
        Student student4 = new Student(4, "王五", "语文", 87.5);
        Student student5 = new Student(5, "王五", "数学", 98.0);
        List<Student> list = new ArrayList<>();
        //添加集合
        list.add(student1);
        list.add(student2);
        list.add(student3);
        list.add(student4);
        list.add(student5);


        //通过steam循环计算
        List<Student> collect = list.stream().map(student -> {
            int c = 0;
            double sum = 0.0;
            for (Student stu : list) {
                if (stu.getName().equals(student.getName())) {
                    sum += stu.getScore();
                    c++;
                }
            }
            double avg = sum / c;
            Student build = Student.builder().name(student.getName())
                    .score(avg).build();
            return build;

        }).distinct().collect(Collectors.toList());
        for (Student student : collect) {
            System.out.println(student.getName()+" "+student.getScore());
        }


    }


}
